Index: sandbox/MultiChannelUSB/UserInterface.tcl
===================================================================
--- sandbox/MultiChannelUSB/UserInterface.tcl	(revision 106)
+++ sandbox/MultiChannelUSB/UserInterface.tcl	(revision 143)
@@ -16,10 +16,54 @@
     namespace import ::blt::tabnotebook
 
-    proc validate {max value} {
+# -------------------------------------------------------------------------
+
+    variable oscCodes
+    array set oscCodes {
+        1 {Channel 1}
+        2 {Channel 2}
+        3 {Channel 3}
+        4 {Channel 4}
+        5 {Channel 5}
+        6 {Trigger}
+    }
+
+# -------------------------------------------------------------------------
+
+    variable adcCodes
+    array set adcCodes {
+        1 {ADC 1}
+        2 {ADC 2}
+        3 {ADC 3}
+        4 {ADC 4}
+        5 {ADC 5}
+        6 {ADC 6}
+        7 {ADC 7}
+        8 {ADC 8}
+        9 {ADC 9}
+       10 {ADC 10}
+       11 {ADC 11}
+       12 {ADC 12}
+    }
+
+# -------------------------------------------------------------------------
+
+    variable inpCodes
+    array set inpCodes {
+        0 {r}
+        1 {f}
+        2 {d}
+        3 {c}
+    }
+
+# -------------------------------------------------------------------------
+
+    proc validate {max size value} {
         if {![regexp {^[0-9]*$} $value]} {
+            return 0
+        } elseif {[regexp {^0[0-9]+$} $value]} {
             return 0
         } elseif {$value > $max} {
             return 0
-        } elseif {[string length $value] > 4} {
+        } elseif {[string length $value] > $size} {
             return 0
         } else {
@@ -30,62 +74,161 @@
 # -------------------------------------------------------------------------
 
-    Class Display
-
-# -------------------------------------------------------------------------
-
-    Display instproc usbCmd {command} {
-        global usb_handle
-
-        if {[catch {$usb_handle writeRaw [usb::convert $command]} result]} {
-            puts {Error during write}
-            puts $result
-        }
-    }
-
-# -------------------------------------------------------------------------
-
-    Display instproc usbCmdRead {command width size} {
-        global usb_handle
-
+    proc doublevalidate {max value} {
+        if {![regexp {^[0-9]{0,2}\.?[0-9]{0,3}$} $value]} {
+            return 0
+        } elseif {[regexp {^0[0-9]+$} $value]} {
+            return 0
+        } elseif {$value > $max} {
+            return 0
+        } else {
+            return 1
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    proc legendLabel {master row key title} {
+        label ${master}.${key}_label -anchor w -text ${title}
+        label ${master}.${key}_value -width 10 -anchor e -text {}
+
+        grid ${master}.${key}_label -row ${row} -column 1 -sticky w
+        grid ${master}.${key}_value -row ${row} -column 2 -sticky ew
+    }
+
+# -------------------------------------------------------------------------
+
+    proc legendButton {master row key title var bg {fg black}} {
+        checkbutton ${master}.${key}_check -variable $var
+        label ${master}.${key}_label -anchor w -text ${title} -bg ${bg} -fg $fg
+        label ${master}.${key}_value -width 10 -anchor e -text {} -bg ${bg} -fg $fg
+
+        grid ${master}.${key}_check -row ${row} -column 0 -sticky w
+        grid ${master}.${key}_label -row ${row} -column 1 -sticky w
+        grid ${master}.${key}_value -row ${row} -column 2 -sticky ew
+    }
+
+# -------------------------------------------------------------------------
+
+    Class UsbController
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbConnect {} {
+        my instvar handle
+
+        puts usbConnect
+
+        if {[my exists handle]} {
+            $handle disconnect
+            unset handle
+        }
+if {1} {
+        while {[catch {usb::connect 0x09FB 0x6001 1 1 0} result]} {
+            set answer [tk_messageBox -icon error -type retrycancel \
+                -message {Cannot access USB device} -detail $result]
+#            puts $result
+            if {[string equal $answer cancel]} exit
+        }
+
+        set handle $result
+
+}
+    }
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbHandle {} {
+        my instvar handle
+
+        if {[my exists handle]} {
+            return $handle
+        } else {
+            my usbConnect
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbCmd {command} {
+        set code [catch {[my usbHandle] writeRaw [usb::convert $command]} result]
+        switch -- $code {
+            1 {
+#                puts $result
+                my usbConnect
+            }
+        }
+
+    }
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbCmdReadRaw {command size data} {
         my usbCmd $command
 
-        set usb_data {}
-        if {[catch {$usb_handle readHex $width $size} result]} {
-            puts {Error during read}
-            puts $result
-            set result {}
-        }
-
-        my set data $result
-    }
-
-# -------------------------------------------------------------------------
-
-    Display instproc usbCmdReadEpt {command size} {
-        global usb_handle
-
+        set code [catch {[my usbHandle] readRaw $size} result]
+        switch -- $code {
+            0 {
+                set $data $result
+            }
+            1 {
+#                puts $result
+                my usbConnect
+            }
+            5 {
+#                puts Busy
+            }
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbCmdReadRaw {command size data} {
         my usbCmd $command
 
-        set usb_data {}
-        if {[catch {$usb_handle readEpt $size} result]} {
-            puts {Error during read}
-            puts $result
-            set result {}
-        }
-
-        my set data $result
-    }
-
-# -------------------------------------------------------------------------
-
-    Class CfgDisplay -superclass Display -parameter {
+        set code [catch {[my usbHandle] readRaw $size} result]
+        switch -- $code {
+            0 {
+                set $data $result
+            }
+            1 {
+#                puts $result
+                my usbConnect
+            }
+            5 {
+#                puts Busy
+            }
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    UsbController instproc usbCmdReadHex {command width size data} {
+        my usbCmd $command
+
+        set code [catch {[my usbHandle] readHex $width $size} result]
+        switch -- $code {
+            0 {
+                set $data $result
+            }
+            1 {
+#                puts $result
+                my usbConnect
+            }
+            5 {
+#                puts Busy
+            }
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    Class SpiDisplay -parameter {
         {master}
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc init {} {
-
-        my reset
+        {controller}
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc init {} {
 
         my setup
@@ -96,5 +239,5 @@
 # -------------------------------------------------------------------------
 
-    CfgDisplay instproc destroy {} {
+    SpiDisplay instproc destroy {} {
         next
     }
@@ -102,46 +245,28 @@
 # -------------------------------------------------------------------------
 
-    CfgDisplay instproc reset {} {
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc start {} {
+    SpiDisplay instproc start {} {
         my instvar config
 
         trace add variable [myvar dac1] write [myproc dac1_update]
         trace add variable [myvar dac2] write [myproc dac2_update]
-        trace add variable [myvar polar] write [myproc polar_update]
 
         ${config(1)}.dac1 set 0
         ${config(1)}.dac2 set 0
-
-        ${config(2)}.polar1 select
-        ${config(2)}.polar2 select
-        ${config(2)}.polar3 select
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc setup {} {
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc setup {} {
         my instvar number master
         my instvar config
 
         set config(1) [labelframe ${master}.cfg1 -borderwidth 1 -relief sunken -text {DAC}]
-        set config(2) [labelframe ${master}.cfg2 -borderwidth 1 -relief sunken -text {polarity inversion}]
 
         frame ${config(1)}.limits
-        label ${config(1)}.limits.min -text {0.0V}
-        label ${config(1)}.limits.max -text {-3.3V}
-
-        scale ${config(1)}.dac1 -orient vertical -from 0 -to 4095 -tickinterval 500 -variable [myvar dac1]
-        scale ${config(1)}.dac2 -orient vertical -from 0 -to 4095 -tickinterval 0 -variable [myvar dac2]
-
-        checkbutton ${config(2)}.polar1 -text {channel 1} -variable [myvar polar(1)]
-        checkbutton ${config(2)}.polar2 -text {channel 2} -variable [myvar polar(2)]
-        checkbutton ${config(2)}.polar3 -text {channel 3} -variable [myvar polar(3)]
-
-        grid ${config(1)} -sticky ns
-        grid ${config(2)} -sticky ew -pady 7
+        label ${config(1)}.limits.min -text {2.5V}
+        label ${config(1)}.limits.max -text {0.0V}
+
+        scale ${config(1)}.dac1 -orient vertical -from 4095 -to 0 -tickinterval 0 -variable [myvar dac1]
+        scale ${config(1)}.dac2 -orient vertical -from 4095 -to 0 -tickinterval 0 -variable [myvar dac2]
 
         pack ${config(1)}.limits.min -anchor n -side top -pady 10
@@ -150,63 +275,407 @@
         grid ${config(1)}.dac1 ${config(1)}.dac2 ${config(1)}.limits -sticky ns -pady 7
 
-        grid ${config(2)}.polar1
-        grid ${config(2)}.polar2
-        grid ${config(2)}.polar3
-
+        
+        set config(2) [labelframe ${master}.cfg2 -borderwidth 1 -relief sunken -text {ADC}]
+
+        frame ${config(2)}.spc1 -width 130 -height 10
+        frame ${config(2)}.spc2 -width 130 -height 10
+        frame ${config(2)}.spc3 -width 130 -height 10
+
+        button ${config(2)}.reset -text {Reset} -command [myproc adc_reset]
+        button ${config(2)}.pattern -text {Test pattern} -command [myproc adc_pattern]
+        button ${config(2)}.ramp -text {Test ramp} -command [myproc adc_ramp]
+        button ${config(2)}.100mV -text {Test 100 mV} -command [myproc adc_100mV]
+        button ${config(2)}.150mV -text {Test 150 mV} -command [myproc adc_150mV]
+        button ${config(2)}.fltr0 -text {Filter 14MHz} -command [myproc adc_fltr0]
+        button ${config(2)}.fltr1 -text {Filter 10MHz} -command [myproc adc_fltr1]
+        button ${config(2)}.fltr2 -text {Filter 7.5MHz} -command [myproc adc_fltr2]
+
+        grid ${config(2)}.spc1
+        grid ${config(2)}.reset -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.spc2
+        grid ${config(2)}.pattern -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.ramp -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.100mV -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.150mV -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.spc3
+        grid ${config(2)}.fltr0 -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.fltr1 -sticky ew -pady 3 -padx 5
+        grid ${config(2)}.fltr2 -sticky ew -pady 3 -padx 5
+
+        grid ${config(1)} -row 1 -column 1 -sticky ns
+        grid ${config(2)} -row 1 -column 2 -sticky ns
+
+		grid columnconfigure ${master} 0 -weight 1
+		grid columnconfigure ${master} 1 -weight 1
+		grid columnconfigure ${master} 2 -weight 1
+		grid columnconfigure ${master} 3 -weight 1
+
+		grid rowconfigure ${master} 0 -weight 0
+		grid rowconfigure ${master} 1 -weight 1
+		grid rowconfigure ${master} 2 -weight 0
+
+        grid rowconfigure ${config(1)} 0 -weight 1
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc dac1_update args {
+        my instvar controller dac1
+
+        set value [format {3%03x} $dac1]
+
+        set prefix [format {%x} 12]
+
+        set command {}
+        append command 0001${prefix}00000020000000402[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 3]00
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc dac2_update args {
+        my instvar controller dac2
+
+        set value [format {b%03x} $dac1]
+
+        set prefix [format {%x} 12]
+
+        set command {}
+        append command 0001${prefix}00000020000000402[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 3]00
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_reset args {
+        my instvar controller
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+
+        set value {000001}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        set value {040008}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_pattern args {
+        my instvar controller
+
+        set value {022000}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_ramp args {
+        my instvar controller
+
+        set value {02E000}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_100mV args {
+        my instvar controller
+
+        set value {070080}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_150mV args {
+        my instvar controller
+
+        set value {070180}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_fltr0 args {
+        my instvar controller
+
+        set value {070000}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_fltr1 args {
+        my instvar controller
+
+        set value {070004}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    SpiDisplay instproc adc_fltr2 args {
+        my instvar controller
+
+        set value {070008}
+
+        set prefix [format {%x} 12]
+        
+        set command {}
+        append command 0001${prefix}00000020000000401[string range $value 0 1]
+        append command 0001${prefix}000000200000004[string range $value 2 5]
+
+        $controller usbCmd $command
+    }
+
+# -------------------------------------------------------------------------
+
+    Class MuxDisplay -parameter {
+        {master}
+        {controller}
+    }
+
+# -------------------------------------------------------------------------
+
+    MuxDisplay instproc init {} {
+
+        my setup
+
+        next
+    }
+
+# -------------------------------------------------------------------------
+
+    MuxDisplay instproc destroy {} {
+        next
+    }
+
+# -------------------------------------------------------------------------
+
+    MuxDisplay instproc start {} {
+        variable adcCodes
+        my instvar config chan_val
+
+        set chan_val(1) 0
+        set chan_val(2) 0
+        set chan_val(3) 0
+        set chan_val(4) 0
+        set chan_val(5) 0
+        set chan_val(6) 0
+
+        trace add variable [myvar chan_val] write [myproc chan_val_update]
+        trace add variable [myvar polar] write [myproc polar_update]
+
+        $config(1).chan_0_1 select
+        $config(2).chan_0_2 select
+        $config(3).chan_0_3 select
+        $config(4).chan_0_4 select
+        $config(5).chan_0_5 select
+        $config(6).chan_0_1 select
+
+        foreach {ch dummy} [array get adcCodes] {
+          $config(inv).polar_${ch} deselect
+        }
+    }
+
+# -------------------------------------------------------------------------
+
+    MuxDisplay instproc setup {} {
+        variable oscCodes
+        variable adcCodes
+        variable inpCodes
+        my instvar master
+        my instvar config
+
+        set size [array size inpCodes]
+        set oscList [array get oscCodes]
+        set adcList [array get adcCodes]
+        set inpList [array get inpCodes]
+
+        set mux [frame ${master}.mux]
+        set key [frame ${master}.key]
+        set inv [frame ${master}.inv]
+        
+        foreach {osc title} $oscList {
+            set config($osc) [labelframe ${mux}.$osc -borderwidth 1 -relief sunken -text $title]
+            set column 1
+            foreach {code input} $inpList {
+                label $config($osc).input_${input} -text " ${input}"
+                grid $config($osc).input_${input} -row 0 -column ${column} -sticky w
+                incr column
+            }
+            foreach {ch dummy} $adcList {
+                label $config($osc).chan_${ch} -text "${ch} "
+                grid $config($osc).chan_${ch} -row ${ch} -column 0 -sticky ew
+                foreach {code input} $inpList {
+                    set column [expr {$code + 1}]
+                    set value [expr {$size * ($ch - 1) + $code}]
+                    radiobutton $config($osc).chan_${code}_${ch} -variable [myvar chan_val($osc)] -value ${value}
+                    grid $config($osc).chan_${code}_${ch} -row ${ch} -column ${column} -sticky w
+                }
+            }
+            set column [expr {($osc - 1) % 6}]
+            set row [expr {($osc - 1) / 6}]
+            grid $config($osc) -row ${row} -column ${column} -sticky news -padx 10
+        }
+
+        set config(key) [labelframe ${key}.frame -borderwidth 1 -relief sunken -text {legend}]
+
+        label $config(key).r -text "r - raw signal"
+        grid $config(key).r -row 0 -column 0 -sticky news
+
+        label $config(key).f -text "f - filtered signal"
+        grid $config(key).f -row 0 -column 1 -sticky news
+ 
+        label $config(key).d -text "d - deconvoluted signal"
+        grid $config(key).d -row 0 -column 2 -sticky news
+ 
+        label $config(key).c -text "c - clipped signal"
+        grid $config(key).c -row 0 -column 3 -sticky news
+
+        grid $config(key) -row 0 -column 0 -sticky news -padx 10
+
+        
+        set config(inv) [labelframe ${inv}.frame -borderwidth 1 -relief sunken -text {polarity inversion}]
+        label $config(inv).chan_label -text "channel "
+        grid $config(inv).chan_label -row 0 -column 0 -sticky e
+        label $config(inv).polar_label -text "polarity"
+        grid $config(inv).polar_label -row 1 -column 0 -sticky e
+        foreach {ch dummy} $adcList {
+            label $config(inv).chan_${ch} -text "${ch} "
+            grid $config(inv).chan_${ch} -row 0 -column ${ch} -sticky ew
+            checkbutton $config(inv).polar_${ch} -variable [myvar polar($ch)]
+            grid $config(inv).polar_${ch} -row 1 -column ${ch} -sticky w
+        }
+        grid $config(inv) -row 0 -column 0 -sticky news -padx 10
+
+        grid ${key} -row 0 -column 0 -sticky news
+        grid ${mux} -row 1 -column 0 -sticky news
+        grid ${inv} -row 2 -column 0 -sticky news
+
+        grid columnconfigure ${master} 0 -weight 1
         grid rowconfigure ${master} 0 -weight 1
-        grid rowconfigure ${config(1)} 0 -weight 1
-        grid rowconfigure ${config(2)} 0 -weight 1
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc dac1_update args {
-        my instvar dac1
-
-        set value [format {%03x} $dac1]
-        set command 0005012000050030000500[string range $value 0 1]000502[string index $value 2]0
-
-        my usbCmd $command
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc dac2_update args {
-        my instvar dac2
-
-        set value [format {%03x} $dac2]
-        set command 0005012400050030000500[string range $value 0 1]000502[string index $value 2]0
-
-        my usbCmd $command
-    }
-
-# -------------------------------------------------------------------------
-
-    CfgDisplay instproc polar_update args {
-        my instvar polar
-
-        set value [format {0%x%x%x} $polar(3) $polar(2) $polar(1)]
-
-        my usbCmd 000A${value}
-    }
-
-# -------------------------------------------------------------------------
-
-    Class OscDisplay -superclass Display -parameter {
+        grid rowconfigure ${master} 1 -weight 1
+        grid rowconfigure ${master} 2 -weight 1
+
+        grid columnconfigure ${inv} 0 -weight 1
+
+        grid columnconfigure ${key} 0 -weight 1
+        grid columnconfigure $config(key) 0 -weight 1
+        grid columnconfigure $config(key) 1 -weight 1
+        grid columnconfigure $config(key) 2 -weight 1
+        grid columnconfigure $config(key) 3 -weight 1
+
+        
+        grid columnconfigure ${mux} 0 -weight 1
+        grid columnconfigure ${mux} 1 -weight 1
+        grid columnconfigure ${mux} 2 -weight 1
+        grid columnconfigure ${mux} 3 -weight 1
+        grid columnconfigure ${mux} 4 -weight 1
+        grid columnconfigure ${mux} 5 -weight 1
+
+
+    }
+
+
+# ------------------------------------------------------------------------
+
+    MuxDisplay instproc chan_val_update args {
+        my instvar controller chan_val
+
+        set byte1 [format {%02x%02x} $chan_val(2) $chan_val(1)]
+        set byte2 [format {%02x%02x} $chan_val(4) $chan_val(3)]
+        set byte3 [format {%02x%02x} $chan_val(6) $chan_val(5)]
+
+        $controller usbCmd 000200020004${byte1}000200030004${byte2}000200040004${byte3}
+    }
+
+# -------------------------------------------------------------------------
+
+    MuxDisplay instproc polar_update args {
+        my instvar controller polar
+        
+        set value {0b}
+        for {set i 12} {$i >= 1} {incr i -1} {
+            append value $polar($i)  
+        }
+
+        set value [format {%04x} $value]
+
+        $controller usbCmd 000200010004${value}
+    }
+
+# -------------------------------------------------------------------------
+
+    Class HstDisplay -parameter {
         {number}
         {master}
-    }
-
-# -------------------------------------------------------------------------
-
-    OscDisplay instproc init {} {
-        my instvar data xvec yvec
-
-        set xvec [vector #auto]
-        set yvec [vector #auto]
-        # fill one vector for the x axis with 1025 points
-        $xvec seq 0 1024
-
-        my reset
+        {controller}
+    }
+
+# -------------------------------------------------------------------------
+
+    HstDisplay instproc init {} {
+
+        my set data {}
+
+        vector create [myvar xvec](4096)
+        vector create [myvar yvec](4096)
+
+        # fill one vector for the x axis with 4096 points
+        [myvar xvec] seq -0.5 4095.5
 
         my setup
@@ -217,5 +686,5 @@
 # -------------------------------------------------------------------------
 
-    OscDisplay instproc destroy {} {
+    HstDisplay instproc destroy {} {
         next
     }
